import os, sys

def fileatonce(path):
    path = os.path.abspath(path)
    #if os.path.exists(path):
    try:
        fd = open(path)
    except IOError, msg:
        exit(msg)
        
    data = fd.read()
    fd.close()
    return data

def snes9x_config_codex(string):
    #FIXME make this reverseable to write .cfg file
    docArray = []
    docDict = {}
    for line in string.splitlines():            
        newLine = []
        for eachChar in line:
            #remove comments
            if eachChar == "#":
                newLine.append(line[:line.index(eachChar)])
        #remove empty lists
        if (len(newLine) > 0) and ((len(newLine) == 1) and (newLine[0] != "")):
            #remove white space
            #FIXME removes to much white space
            newLine = ''.join(newLine)
            #TEMPORARY FIX
            if newLine[:3] != ("Dir" or "Rom"): 
                newLine = newLine.split()
                newLine = ''.join(newLine)
            else:
                key_idx = newLine.index("=")
                key = newLine[:key_idx].rstrip()
                
                value_idx = key_idx+2
                value = newLine[value_idx:].rstrip()
                
                newLine = key+'='+value
                #print newLine
                
            docArray.append(newLine)
            #write a dict
            key = newLine[:newLine.index("=")]
            value = newLine[newLine.index("=")+1:]
            docDict[key] = value
            
    return (docArray, docDict)
        
    
class Config(object):
    def __init__(self, path):
        self.data = fileatonce(path)
        self.list = snes9x_config_codex(self.data)[0]
        self.dict = snes9x_config_codex(self.data)[1]
        
    
class CliApp(object):
    def __init__(self, conf_path = None):
        if conf_path != None:
            self.config = Config(conf_path)
            self.namelist, self.pathlist, self.dictbyname, self.dictbypath = self.listDirectory(self.config.dict["Dir:Roms"])
            if os.name == "nt":
            #windows binary
                self.snes9xbin = os.path.abspath(os.path.join(conf_path[:conf_path.rfind(os.path.basename(conf_path))], "snes9x.exe"))
            #linux
            elif os.name == "posix":
                self.snes9xbin = "snes9x"
            else:
                print "Unknown OS"
                exit()
        else:
            #fixme wrong error type
            raise TypeError, "No Config path given"
            
    def listDirectory(self, directory_path):
        path = os.path.normpath(directory_path)
        if os.path.isdir(path):
            roms = os.listdir(path)
            paths = []
            dictbyname = {}
            dictbypath = {}
            for i in roms:
                dictbyname[i] = os.path.abspath(os.path.join(directory_path, i))
                dictbypath[os.path.abspath(os.path.join(directory_path, i))] = i
                paths.append(os.path.abspath(os.path.join(directory_path, i)))
            return (roms, paths, dictbyname, dictbypath)
        else:
            raise TypeError, "Not a valid directory wah wah"

    def getPathFromIndex(self, idx):
        return self.pathlist[idx]
    def getPathFromName(self, idx):
        return self.dictbyname[idx]
        
if __name__ == '__main__':
    path = __file__[:__file__.rfind(os.path.sep)]
    app = CliApp(os.path.join(path, "snes9x.conf"))
        